<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Document</title>
    <style type="text/css" media="screen">
        .punto {
            /*background-color: black;*/
            position: absolute;
            left: 0px;
            top: 0px;
            width: 1px;
            height: 1px;
        }
    </style>
    <script type="text/javascript">
        /**
         * clase
         */
        let Cuadrado = function(id, i, d, ancho = 10, alto = 10, c) {
            // propiedades privadas
            let izquierda;
            let arriba;
            let atributoId;
            let color;

            // propiedades publicas
            // mejor inicializarlas porque si no, no la crea
            this.ancho = 10;
            this.alto = 10;

            // constructor: metodo publico
            this.Cuadrado = function(id, i, d, ancho = 10, alto = 10, c) { //ancho=10, alto=10 es opcional porque ya está en la creación de la clase
                // inicializar los miembros
                izquierda = i;
                arriba = d;
                this.ancho = ancho;
                this.alto = alto;
                atributoId = id;
                color = c;


                // pintamos una caja en el body
                document.querySelector("body").innerHTML += '<div class="punto" id="' + atributoId + '">&nbsp;</div>';
                document.querySelector("#" + atributoId).style.top = this.getArriba();
                document.querySelector("#" + atributoId).style.left = this.getIzquierda();
                document.querySelector("#" + atributoId).style.width = this.ancho + "px";
                document.querySelector("#" + atributoId).style.height = this.alto + "px";
                document.querySelector("#" + atributoId).style.backgroundColor = this.getColor();


            };

            // elemento estático de tipo propiedad
            // miembro inventado
            Cuadrado.unidades = "px";


            /**
             * getter y setter
             */
            this.setIzquierda = function(valor) {
                izquierda = valor;
            }

            this.setArriba = function(valor) {
                arriba = valor;
            }

            this.setColor = function(valor) {
                color = valor;
            }

            this.getIzquierda = function() {
                return izquierda + Cuadrado.unidades;
            }

            this.getArriba = function() {
                return arriba + Cuadrado.unidades;
            }

            this.getColor = function() {
                return color;
            }

            // la llamada al constructor tiene que estar al final
            this.Cuadrado(id, i, d, ancho, alto, c);
        }


        window.addEventListener("load", (e) => {
            let uno = new Cuadrado("caja1", 10, 20, 100, 50, "ORANGE");
            /* let dos = new Cuadrado("caja2", 100, 20, 100, 200);*/
            let dos = new Cuadrado("caja2", 100, 20, 100, 200, "BLUE");
            //dos.setArriba(100);
            //dos.setIzquierda(200);
            // añadir color
            //console.log(uno.getArriba());
            //console.log(uno);		
            //console.log(dos.getArriba());
            //Cuadrado.unidades="pt";
            //console.log(uno.getArriba());
            //console.log(dos.getArriba());

        });


        /**
         * Crear objeto
         */
    </script>
</head>

<body>

</body>

</html>